diff --git a/base/deploy/src/scriptlets/pkiparser.py b/base/deploy/src/scriptlets/pkiparser.py
index 0add192..5abfdc0 100644
--- a/base/deploy/src/scriptlets/pkiparser.py
+++ b/base/deploy/src/scriptlets/pkiparser.py
@@ -992,10 +1383,778 @@ def compose_pki_master_dictionary():
                          "pki",
                          "deployment",
                          "configuration.jy")
+        config.pki_master_dict['pki_jython_base_uri'] =\
+            "https" + "://" + config.pki_master_dict['pki_hostname'] + ":" +\
+            config.pki_master_dict['pki_https_port'] + "/" +\
+            config.pki_master_dict['pki_subsystem'].lower() + "/" + "pki"
+        # Jython scriptlet
+        # 'Security Domain' Configuration name/value pairs
+        #
+        #     Apache - [RA], [TPS]
+        #     Tomcat - [CA], [KRA], [OCSP], [TKS]
+        #            - [CA Clone], [KRA Clone], [OCSP Clone], [TKS Clone]
+        #            - [External CA]
+        #            - [Subordinate CA]
+        #
+        #     The following variables are defined below:
+        #
+        #         config.pki_master_dict['pki_security_domain_type']
+        #         config.pki_master_dict['pki_security_domain_uri']
+        #
+        #     The following variables are established via the specified PKI
+        #     deployment configuration file and are NOT redefined below:
+        #
+        #         config.pki_master_dict['pki_security_domain_https_port']
+        #         config.pki_master_dict['pki_security_domain_password']
+        #         config.pki_master_dict['pki_security_domain_user']
+        #
+        #     The following variables are established via the specified PKI
+        #     deployment configuration file and potentially overridden below:
+        #
+        #         config.pki_master_dict['pki_security_domain_hostname']
+        #         config.pki_master_dict['pki_security_domain_name']
+        #
+        if config.pki_subsystem in config.PKI_TOMCAT_SUBSYSTEMS:
+            if config.pki_subsystem == "CA":
+                if config.str2bool(config.pki_master_dict['pki_external']):
+                    # External CA
+                    config.pki_master_dict['pki_security_domain_type'] = "new"
+                    if not len(config.pki_master_dict\
+                               ['pki_security_domain_name']):
+                        config.pki_master_dict['pki_security_domain_name'] =\
+                            "External CA Security Domain"
+                elif not config.str2bool(config.pki_master_dict['pki_clone'])\
+                     and not\
+                     config.str2bool(config.pki_master_dict['pki_subordinate']):
+                    # PKI CA
+                    config.pki_master_dict['pki_security_domain_type'] = "new"
+                    if not len(config.pki_master_dict\
+                               ['pki_security_domain_name']):
+                        config.pki_master_dict['pki_security_domain_name'] =\
+                            config.pki_master_dict['pki_dns_domainname'] +\
+                            " " + "Security Domain"
+                else:
+                    # PKI Cloned or Subordinate CA
+                    config.pki_master_dict['pki_security_domain_type'] =\
+                        "existing"
+                    if not len(config.pki_master_dict\
+                               ['pki_security_domain_hostname']):
+                        # Guess that it is the local host
+                        config.pki_master_dict['pki_security_domain_hostname']\
+                            = config.pki_master_dict['pki_hostname']
+                    config.pki_master_dict['pki_security_domain_uri'] =\
+                        "https" + "://" +\
+                        config.pki_master_dict['pki_security_domain_hostname']\
+                        + ":" + config.pki_security_domain_https_port
+            else:
+                # PKI KRA, OCSP, or TKS
+                config.pki_master_dict['pki_security_domain_type'] = "existing"
+                if not len(config.pki_master_dict\
+                           ['pki_security_domain_hostname']):
+                    # Guess that it is the local host
+                    config.pki_master_dict['pki_security_domain_hostname'] =\
+                        config.pki_master_dict['pki_hostname']
+                config.pki_master_dict['pki_security_domain_uri'] =\
+                    "https" + "://" +\
+                    config.pki_master_dict['pki_security_domain_hostname'] +\
+                    ":" +\
+                    config.pki_master_dict['pki_security_domain_https_port']
+        # Jython scriptlet
+        # 'Directory Server' Configuration name/value pairs
+        #
+        #     Apache - [TPS]
+        #     Tomcat - [CA], [KRA], [OCSP], [TKS]
+        #            - [CA Clone], [KRA Clone], [OCSP Clone], [TKS Clone]
+        #            - [External CA]
+        #            - [Subordinate CA]
+        #
+        #     The following variables are established via the specified PKI
+        #     deployment configuration file and are NOT redefined below:
+        #
+        #         config.pki_master_dict['pki_ds_bind_dn']
+        #         config.pki_master_dict['pki_ds_http_port']
+        #         config.pki_master_dict['pki_ds_https_port']
+        #         config.pki_master_dict['pki_ds_password']
+        #         config.pki_master_dict['pki_ds_remove_data']
+        #         config.pki_master_dict['pki_ds_secure_connection']
+        #
+        #     The following variables are established via the specified PKI
+        #     deployment configuration file and potentially overridden below:
+        #
+        #         config.pki_master_dict['pki_ds_base_dn']
+        #         config.pki_master_dict['pki_ds_database']
+        #         config.pki_master_dict['pki_ds_hostname']
+        #
+        if not len(config.pki_master_dict['pki_ds_base_dn']):
+            config.pki_master_dict['pki_ds_base_dn'] =\
+                "o=" + config.pki_master_dict['pki_instance_id']
+        if not len(config.pki_master_dict['pki_ds_database']):
+            config.pki_master_dict['pki_ds_database'] =\
+                "o=" + config.pki_master_dict['pki_instance_id']
+        if not len(config.pki_master_dict['pki_ds_hostname']):
+            # Guess that the Directory Server resides on the local host
+            config.pki_master_dict['pki_ds_hostname'] =\
+                config.pki_master_dict['pki_hostname']
+        # Jython scriptlet
+        # 'Backup' Configuration name/value pairs
+        #
+        #     Apache - [RA], [TPS]
+        #     Tomcat - [CA], [KRA], [OCSP], [TKS]
+        #            - [External CA]
+        #            - [Subordinate CA]
+        #
+        #     The following variables are established via the specified PKI
+        #     deployment configuration file and are NOT redefined below:
+        #
+        #        config.pki_master_dict['pki_backup_keys']
+        #        config.pki_master_dict['pki_backup_password']
+        #
+        #     The following variables are established via the specified PKI
+        #     deployment configuration file and potentially overridden below:
+        #
+        #        config.pki_master_dict['pki_backup_file']
+        #
+        if config.str2bool(config.pki_master_dict['pki_backup_keys']):
+            if not len(config.pki_master_dict['pki_backup_file']):
+                if config.pki_subsystem in config.PKI_TOMCAT_SUBSYSTEMS:
+                    if not config.str2bool(config.pki_master_dict['pki_clone']):
+                        if config.pki_master_dict['pki_subsystem'] == "CA":
+                            if config.str2bool(
+                                   config.pki_master_dict['pki_external']):
+                                # External CA
+                                config.pki_master_dict['pki_backup_file'] =\
+                                    "/tmp" + "/" + "externalca.p12" + "." +\
+                                    config.pki_master_dict['pki_timestamp']
+                            elif config.str2bool(
+                                     config.pki_master_dict['pki_subordinate']):
+                                # Subordinate CA
+                                config.pki_master_dict['pki_backup_file'] =\
+                                    "/tmp" + "/" + "subca.p12" + "." +\
+                                    config.pki_master_dict['pki_timestamp']
+                            else:
+                                # PKI CA
+                                config.pki_master_dict['pki_backup_file'] =\
+                                    "/tmp" + "/" + "ca.p12" + "." +\
+                                    config.pki_master_dict['pki_timestamp']
+                        elif config.pki_master_dict['pki_subsystem'] == "KRA":
+                            # PKI KRA
+                            config.pki_master_dict['pki_backup_file'] =\
+                                "/tmp" + "/" + "kra.p12" + "." +\
+                                config.pki_master_dict['pki_timestamp']
+                        elif config.pki_master_dict['pki_subsystem'] == "OCSP":
+                            # PKI OCSP
+                            config.pki_master_dict['pki_backup_file'] =\
+                                "/tmp" + "/" + "ocsp.p12" + "." +\
+                                config.pki_master_dict['pki_timestamp']
+                        elif config.pki_master_dict['pki_subsystem'] == "TKS":
+                            # PKI TKS
+                            config.pki_master_dict['pki_backup_file'] =\
+                                "/tmp" + "/" + "tks.p12" + "." +\
+                                config.pki_master_dict['pki_timestamp']
+        # Jython scriptlet
+        # 'Admin Certificate' Configuration name/value pairs
+        #
+        #     Apache - [RA], [TPS]
+        #     Tomcat - [CA], [KRA], [OCSP], [TKS]
+        #            - [External CA]
+        #            - [Subordinate CA]
+        #
+        #     The following variables are established via the specified PKI
+        #     deployment configuration file and are NOT redefined below:
+        #
+        #         config.pki_master_dict['pki_admin_cert_request_type']
+        #         config.pki_master_dict['pki_admin_dualkey']
+        #         config.pki_master_dict['pki_admin_keysize']
+        #         config.pki_master_dict['pki_admin_name']
+        #         config.pki_master_dict['pki_admin_password']
+        #         config.pki_master_dict['pki_admin_uid']
+        #
+        #     The following variables are established via the specified PKI
+        #     deployment configuration file and potentially overridden below:
+        #
+        #         config.pki_master_dict['pki_admin_email']
+        #         config.pki_master_dict['pki_admin_subject_dn']
+        #
+        config.pki_master_dict['pki_admin_profile_id'] = "caAdminCert"
+        if not len(config.pki_master_dict['pki_admin_email']):
+            config.pki_master_dict['pki_admin_email'] =\
+                config.pki_master_dict['pki_admin_name'] + "@" +\
+                config.pki_master_dict['pki_dns_domainname']
+        if not len(config.pki_master_dict['pki_admin_subject_dn']):
+            if config.pki_subsystem in config.PKI_APACHE_SUBSYSTEMS:
+                if config.pki_master_dict['pki_subsystem'] == "RA":
+                    # PKI RA
+                    config.pki_master_dict['pki_admin_subject_dn'] =\
+                        "cn=" + "RA Administrator" + "," +\
+                        "uid=" + config.pki_master_dict['pki_admin_uid'] +\
+                        "," + "e=" +\
+                        config.pki_master_dict['pki_admin_email'] +\
+                        "," + "o=" +\
+                        config.pki_master_dict['pki_security_domain_name']
+                elif config.pki_master_dict['pki_subsystem'] == "TPS":
+                    # PKI TPS
+                    config.pki_master_dict['pki_admin_subject_dn'] =\
+                        "cn=" + "TPS Administrator" + "," +\
+                        "uid=" + config.pki_master_dict['pki_admin_uid'] +\
+                        "," + "e=" +\
+                        config.pki_master_dict['pki_admin_email'] +\
+                        "," + "o=" +\
+                        config.pki_master_dict['pki_security_domain_name']
+            elif config.pki_subsystem in config.PKI_TOMCAT_SUBSYSTEMS:
+                if not config.str2bool(config.pki_master_dict['pki_clone']):
+                    if config.pki_master_dict['pki_subsystem'] == "CA":
+                        # PKI CA, Subordinate CA, or External CA
+                        config.pki_master_dict['pki_admin_subject_dn'] =\
+                            "cn=" + "CA Administrator of Instance" + " " +\
+                            config.pki_master_dict['pki_instance_id'] + "," +\
+                            "uid=" + config.pki_master_dict['pki_admin_uid'] +\
+                            "," + "e=" +\
+                            config.pki_master_dict['pki_admin_email'] +\
+                            "," + "o=" +\
+                            config.pki_master_dict['pki_security_domain_name']
+                    elif config.pki_master_dict['pki_subsystem'] == "KRA":
+                        # PKI KRA
+                        config.pki_master_dict['pki_admin_subject_dn'] =\
+                            "cn=" + "KRA Administrator of Instance" + " " +\
+                            config.pki_master_dict['pki_instance_id'] + "," +\
+                            "uid=" + config.pki_master_dict['pki_admin_uid'] +\
+                            "," + "e=" +\
+                            config.pki_master_dict['pki_admin_email'] +\
+                            "," + "o=" +\
+                            config.pki_master_dict['pki_security_domain_name']
+                    elif config.pki_master_dict['pki_subsystem'] == "OCSP":
+                        # PKI OCSP
+                        config.pki_master_dict['pki_admin_subject_dn'] =\
+                            "cn=" + "OCSP Administrator of Instance" + " " +\
+                            config.pki_master_dict['pki_instance_id'] + "," +\
+                            "uid=" + config.pki_master_dict['pki_admin_uid'] +\
+                            "," + "e=" +\
+                            config.pki_master_dict['pki_admin_email'] +\
+                            "," + "o=" +\
+                            config.pki_master_dict['pki_security_domain_name']
+                    elif config.pki_master_dict['pki_subsystem'] == "TKS":
+                        # PKI TKS
+                        config.pki_master_dict['pki_admin_subject_dn'] =\
+                            "cn=" + "TKS Administrator of Instance" + " " +\
+                            config.pki_master_dict['pki_instance_id'] + "," +\
+                            "uid=" + config.pki_master_dict['pki_admin_uid'] +\
+                            "," + "e=" +\
+                            config.pki_master_dict['pki_admin_email'] +\
+                            "," + "o=" +\
+                            config.pki_master_dict['pki_security_domain_name']
+        # Jython scriptlet
+        # 'CA Signing Certificate' Configuration name/value pairs
+        #
+        #     Tomcat - [CA]
+        #            - [External CA]
+        #            - [Subordinate CA]
+        #
+        #     The following variables are defined below:
+        #
+        #         config.pki_master_dict['pki_ca_signing_tag']
+        #
+        #     The following variables are established via the specified PKI
+        #     deployment configuration file and are NOT redefined below:
+        #
+        #         config.pki_master_dict['pki_ca_signing_key_algorithm']
+        #         config.pki_master_dict['pki_ca_signing_key_size']
+        #         config.pki_master_dict['pki_ca_signing_key_type']
+        #         config.pki_master_dict['pki_ca_signing_signing_algorithm']
+        #
+        #     The following variables are established via the specified PKI
+        #     deployment configuration file and potentially overridden below:
+        #
+        #         config.pki_master_dict['pki_ca_signing_nickname']
+        #         config.pki_master_dict['pki_ca_signing_subject_dn']
+        #         config.pki_master_dict['pki_ca_signing_token']
+        #
+        if config.pki_subsystem in config.PKI_TOMCAT_SUBSYSTEMS:
+            if not config.str2bool(config.pki_master_dict['pki_clone']):
+                if config.pki_master_dict['pki_subsystem'] == "CA":
+                    # config.pki_master_dict['pki_ca_signing_nickname']
+                    if not len(config.pki_master_dict\
+                               ['pki_ca_signing_nickname']):
+                        config.pki_master_dict['pki_ca_signing_nickname'] =\
+                            "caSigningCert" + " " + "cert-" +\
+                            config.pki_master_dict['pki_instance_id']
+                    # config.pki_master_dict['pki_ca_signing_subject_dn']
+                    if config.str2bool(config.pki_master_dict['pki_external']):
+                        # External CA
+                        if not len(config.pki_master_dict\
+                                   ['pki_ca_signing_subject_dn']):
+                            config.pki_master_dict['pki_ca_signing_subject_dn']\
+                                =  "cn=" + "External CA Signing Certificate" +\
+                                   "," + "o=" +\
+                                   config.pki_master_dict\
+                                   ['pki_security_domain_name']
+                    elif config.str2bool(
+                             config.pki_master_dict['pki_subordinate']):
+                        # Subordinate CA
+                        if not len(config.pki_master_dict\
+                                   ['pki_ca_signing_subject_dn']):
+                            config.pki_master_dict['pki_ca_signing_subject_dn']\
+                                =  "cn=" + "SubCA Signing Certificate" +\
+                                   "," + "o=" +\
+                                   config.pki_master_dict\
+                                   ['pki_security_domain_name']
+                    else:
+                        # PKI CA
+                        if not len(config.pki_master_dict\
+                                   ['pki_ca_signing_subject_dn']):
+                            config.pki_master_dict['pki_ca_signing_subject_dn']\
+                                =  "cn=" + "CA Signing Certificate" +\
+                                   "," + "o=" +\
+                                   config.pki_master_dict\
+                                   ['pki_security_domain_name']
+                    # config.pki_master_dict['pki_ca_signing_tag']
+                    config.pki_master_dict['pki_ca_signing_tag'] =\
+                        "signing"
+                    # config.pki_master_dict['pki_ca_signing_token']
+                    if not len(config.pki_master_dict['pki_ca_signing_token']):
+                        config.pki_master_dict['pki_ca_signing_token'] =\
+                            "Internal Key Storage Token"
+        # Jython scriptlet
+        # 'OCSP Signing Certificate' Configuration name/value pairs
+        #
+        #     Tomcat - [CA], [OCSP]
+        #            - [External CA]
+        #            - [Subordinate CA]
+        #
+        #     The following variables are defined below:
+        #
+        #         config.pki_master_dict['pki_ocsp_signing_tag']
+        #
+        #     The following variables are established via the specified PKI
+        #     deployment configuration file and are NOT redefined below:
+        #
+        #         config.pki_master_dict['pki_ocsp_signing_key_algorithm']
+        #         config.pki_master_dict['pki_ocsp_signing_key_size']
+        #         config.pki_master_dict['pki_ocsp_signing_key_type']
+        #         config.pki_master_dict['pki_ocsp_signing_signing_algorithm']
+        #
+        #     The following variables are established via the specified PKI
+        #     deployment configuration file and potentially overridden below:
+        #
+        #         config.pki_master_dict['pki_ocsp_signing_nickname']
+        #         config.pki_master_dict['pki_ocsp_signing_subject_dn']
+        #         config.pki_master_dict['pki_ocsp_signing_token']
+        #
+        if config.pki_subsystem in config.PKI_TOMCAT_SUBSYSTEMS:
+            if not config.str2bool(config.pki_master_dict['pki_clone']):
+                if config.pki_master_dict['pki_subsystem'] == "CA":
+                    if not len(config.pki_master_dict\
+                               ['pki_ocsp_signing_nickname']):
+                        config.pki_master_dict['pki_ocsp_signing_nickname'] =\
+                            "ocspSigningCert" + " " + "cert-" +\
+                            config.pki_master_dict['pki_instance_id']
+                    if config.str2bool(config.pki_master_dict['pki_external']):
+                        # External CA
+                        if not len(config.pki_master_dict\
+                                   ['pki_ocsp_signing_subject_dn']):
+                            config.pki_master_dict\
+                            ['pki_ocsp_signing_subject_dn'] =\
+                                "cn=" + "External CA OCSP Signing Certificate"\
+                                + "," + "o=" +\
+                                config.pki_master_dict\
+                                ['pki_security_domain_name']
+                    elif config.str2bool(
+                             config.pki_master_dict['pki_subordinate']):
+                        # Subordinate CA
+                        if not len(config.pki_master_dict\
+                                   ['pki_ocsp_signing_subject_dn']):
+                            config.pki_master_dict\
+                            ['pki_ocsp_signing_subject_dn'] =\
+                                "cn=" + "SubCA OCSP Signing Certificate"\
+                                + "," + "o=" +\
+                                config.pki_master_dict\
+                                ['pki_security_domain_name']
+                    else:
+                        # PKI CA
+                        if not len(config.pki_master_dict\
+                                   ['pki_ocsp_signing_subject_dn']):
+                            config.pki_master_dict\
+                            ['pki_ocsp_signing_subject_dn'] =\
+                                "cn=" + "CA OCSP Signing Certificate"\
+                                + "," + "o=" +\
+                                config.pki_master_dict\
+                                ['pki_security_domain_name']
+                    config.pki_master_dict['pki_ocsp_signing_tag'] =\
+                        "ocsp_signing"
+                    if not len(config.pki_master_dict\
+                               ['pki_ocsp_signing_token']):
+                        config.pki_master_dict['pki_ocsp_signing_token'] =\
+                            "Internal Key Storage Token"
+                elif config.pki_master_dict['pki_subsystem'] == "OCSP":
+                    # PKI OCSP
+                    if not len(config.pki_master_dict\
+                               ['pki_ocsp_signing_nickname']):
+                        config.pki_master_dict['pki_ocsp_signing_nickname'] =\
+                            "ocspSigningCert" + " " + "cert-" +\
+                            config.pki_master_dict['pki_instance_id']
+                    if not len(config.pki_master_dict\
+                               ['pki_ocsp_signing_subject_dn']):
+                        config.pki_master_dict['pki_ocsp_signing_subject_dn'] =\
+                            "cn=" + "OCSP Signing Certificate" + "," + "o=" +\
+                            config.pki_master_dict['pki_security_domain_name']
+                    config.pki_master_dict['pki_ocsp_signing_tag'] =\
+                        "signing"
+                    if not len(config.pki_master_dict\
+                               ['pki_ocsp_signing_token']):
+                        config.pki_master_dict['pki_ocsp_signing_token'] =\
+                            "Internal Key Storage Token"
+        # Jython scriptlet
+        # 'SSL Server Certificate' Configuration name/value pairs
+        #
+        #     Apache - [RA], [TPS]
+        #     Tomcat - [CA], [KRA], [OCSP], [TKS]
+        #            - [CA Clone], [KRA Clone], [OCSP Clone], [TKS Clone]
+        #            - [External CA]
+        #            - [Subordinate CA]
+        #
+        #     The following variables are defined below:
+        #
+        #         config.pki_master_dict['pki_ssl_server_tag']
+        #
+        #     The following variables are established via the specified PKI
+        #     deployment configuration file and are NOT redefined below:
+        #
+        #         config.pki_master_dict['pki_ssl_server_key_algorithm']
+        #         config.pki_master_dict['pki_ssl_server_key_size']
+        #         config.pki_master_dict['pki_ssl_server_key_type']
+        #
+        #     The following variables are established via the specified PKI
+        #     deployment configuration file and potentially overridden below:
+        #
+        #         config.pki_master_dict['pki_ssl_server_nickname']
+        #         config.pki_master_dict['pki_ssl_server_subject_dn']
+        #         config.pki_master_dict['pki_ssl_server_token']
+        #
+        if not len(config.pki_master_dict['pki_ssl_server_nickname']):
+            config.pki_master_dict['pki_ssl_server_nickname'] =\
+                "Server-Cert" + " " + "cert-" +\
+                config.pki_master_dict['pki_instance_id']
+        if not len(config.pki_master_dict['pki_ssl_server_subject_dn']):
+            if config.pki_subsystem in config.PKI_APACHE_SUBSYSTEMS:
+                config.pki_master_dict['pki_ssl_server_subject_dn'] =\
+                    "cn=" + config.pki_master_dict['pki_hostname'] +\
+                    "," + "ou=" + config.pki_master_dict['pki_instance_id'] +\
+                    "," + "o=" +\
+                    config.pki_master_dict['pki_security_domain_name']
+            elif config.pki_subsystem in config.PKI_TOMCAT_SUBSYSTEMS:
+                config.pki_master_dict['pki_ssl_server_subject_dn'] =\
+                    "cn=" + config.pki_master_dict['pki_hostname'] +\
+                    "," + "o=" +\
+                    config.pki_master_dict['pki_security_domain_name']
+        config.pki_master_dict['pki_ssl_server_tag'] = "sslserver"
+        if not len(config.pki_master_dict['pki_ssl_server_token']):
+            config.pki_master_dict['pki_ssl_server_token'] =\
+                "Internal Key Storage Token"
+        # Jython scriptlet
+        # 'Subsystem Certificate' Configuration name/value pairs
+        #
+        #     Apache - [RA], [TPS]
+        #     Tomcat - [CA], [KRA], [OCSP], [TKS]
+        #            - [External CA]
+        #            - [Subordinate CA]
+        #
+        #     The following variables are defined below:
+        #
+        #         config.pki_master_dict['pki_subsystem_tag']
+        #
+        #     The following variables are established via the specified PKI
+        #     deployment configuration file and are NOT redefined below:
+        #
+        #         config.pki_master_dict['pki_subsystem_key_algorithm']
+        #         config.pki_master_dict['pki_subsystem_key_size']
+        #         config.pki_master_dict['pki_subsystem_key_type']
+        #
+        #     The following variables are established via the specified PKI
+        #     deployment configuration file and potentially overridden below:
+        #
+        #         config.pki_master_dict['pki_subsystem_nickname']
+        #         config.pki_master_dict['pki_subsystem_subject_dn']
+        #         config.pki_master_dict['pki_subsystem_token']
+        #
+        if config.pki_subsystem in config.PKI_APACHE_SUBSYSTEMS:
+            if not len(config.pki_master_dict['pki_subsystem_nickname']):
+                config.pki_master_dict['pki_subsystem_nickname'] =\
+                    "subsystemCert" + " " + "cert-" +\
+                    config.pki_master_dict['pki_instance_id']
+            if not len(config.pki_master_dict['pki_subsystem_subject_dn']):
+                if config.pki_master_dict['pki_subsystem'] == "RA":
+                    # PKI RA
+                    config.pki_master_dict['pki_subsystem_subject_dn'] =\
+                        "cn=" + "RA Subsystem Certificate" +\
+                        "," + "ou=" + config.pki_master_dict['pki_instance_id']\
+                        + "," + "o=" +\
+                        config.pki_master_dict['pki_security_domain_name']
+                elif config.pki_master_dict['pki_subsystem'] == "TPS":
+                    # PKI TPS
+                    config.pki_master_dict['pki_subsystem_subject_dn'] =\
+                        "cn=" + "TPS Subsystem Certificate" +\
+                        "," + "ou=" + config.pki_master_dict['pki_instance_id']\
+                        + "," + "o=" +\
+                        config.pki_master_dict['pki_security_domain_name']
+            config.pki_master_dict['pki_subsystem_tag'] = "subsystem"
+            if not len(config.pki_master_dict['pki_subsystem_token']):
+                config.pki_master_dict['pki_subsystem_token'] =\
+                    "Internal Key Storage Token"
+        elif config.pki_subsystem in config.PKI_TOMCAT_SUBSYSTEMS:
+            if not config.str2bool(config.pki_master_dict['pki_clone']):
+                if not len(config.pki_master_dict['pki_subsystem_nickname']):
+                    config.pki_master_dict['pki_subsystem_nickname'] =\
+                        "subsystemCert" + " " + "cert-" +\
+                        config.pki_master_dict['pki_instance_id']
+                if not len(config.pki_master_dict['pki_subsystem_subject_dn']):
+                    if config.pki_master_dict['pki_subsystem'] == "CA":
+                        if config.str2bool(
+                               config.pki_master_dict['pki_external']):
+                            # External CA
+                            config.pki_master_dict['pki_subsystem_subject_dn']\
+                                = "cn=" + "External CA Subsystem Certificate" +\
+                                  "," + "o=" +\
+                                  config.pki_master_dict\
+                                  ['pki_security_domain_name']
+                        elif config.str2bool(
+                                 config.pki_master_dict['pki_subordinate']):
+                            # Subordinate CA
+                            config.pki_master_dict['pki_subsystem_subject_dn']\
+                                = "cn=" + "SubCA Subsystem Certificate" +\
+                                  "," + "o=" +\
+                                  config.pki_master_dict\
+                                  ['pki_security_domain_name']
+                        else:
+                            # PKI CA
+                            config.pki_master_dict['pki_subsystem_subject_dn']\
+                                = "cn=" + "CA Subsystem Certificate" +\
+                                  "," + "o=" +\
+                                  config.pki_master_dict\
+                                  ['pki_security_domain_name']
+                    elif config.pki_master_dict['pki_subsystem'] == "KRA":
+                        # PKI KRA
+                        config.pki_master_dict['pki_subsystem_subject_dn'] =\
+                            "cn=" + "DRM Subsystem Certificate" +\
+                            "," + "o=" +\
+                            config.pki_master_dict\
+                            ['pki_security_domain_name']
+                    elif config.pki_master_dict['pki_subsystem'] == "OCSP":
+                        # PKI OCSP
+                        config.pki_master_dict['pki_subsystem_subject_dn'] =\
+                            "cn=" + "OCSP Subsystem Certificate" +\
+                            "," + "o=" +\
+                            config.pki_master_dict\
+                            ['pki_security_domain_name']
+                    elif config.pki_master_dict['pki_subsystem'] == "TKS":
+                        # PKI TKS
+                        config.pki_master_dict['pki_subsystem_subject_dn'] =\
+                            "cn=" + "TKS Subsystem Certificate" +\
+                            "," + "o=" +\
+                            config.pki_master_dict\
+                            ['pki_security_domain_name']
+                config.pki_master_dict['pki_subsystem_tag'] = "subsystem"
+                if not len(config.pki_master_dict['pki_subsystem_token']):
+                    config.pki_master_dict['pki_subsystem_token'] =\
+                        "Internal Key Storage Token"
+        # Jython scriptlet
+        # 'Audit Signing Certificate' Configuration name/value pairs
+        #
+        #     Apache - [TPS]
+        #     Tomcat - [CA], [KRA], [OCSP], [TKS]
+        #            - [External CA]
+        #            - [Subordinate CA]
+        #
+        #     The following variables are defined below:
+        #
+        #         config.pki_master_dict['pki_audit_signing_tag']
+        #
+        #     The following variables are established via the specified PKI
+        #     deployment configuration file and are NOT redefined below:
+        #
+        #         config.pki_master_dict['pki_audit_signing_key_algorithm']
+        #         config.pki_master_dict['pki_audit_signing_key_size']
+        #         config.pki_master_dict['pki_audit_signing_key_type']
+        #         config.pki_master_dict['pki_audit_signing_signing_algorithm']
+        #
+        #     The following variables are established via the specified PKI
+        #     deployment configuration file and potentially overridden below:
+        #
+        #         config.pki_master_dict['pki_audit_signing_nickname']
+        #         config.pki_master_dict['pki_audit_signing_subject_dn']
+        #         config.pki_master_dict['pki_audit_signing_token']
+        #
+        if config.pki_subsystem in config.PKI_APACHE_SUBSYSTEMS:
+            if config.pki_master_dict['pki_subsystem'] != "RA":
+                if not len(config.pki_master_dict\
+                           ['pki_audit_signing_nickname']):
+                    config.pki_master_dict['pki_audit_signing_nickname'] =\
+                        "auditSigningCert" + " " + "cert-" +\
+                        config.pki_master_dict['pki_instance_id']
+                if not len(config.pki_master_dict\
+                           ['pki_audit_signing_subject_dn']):
+                    config.pki_master_dict['pki_audit_signing_subject_dn'] =\
+                        "cn=" + "TPS Audit Signing Certificate" +\
+                        "," + "ou=" + config.pki_master_dict['pki_instance_id']\
+                        + "," + "o=" +\
+                        config.pki_master_dict['pki_security_domain_name']
+                config.pki_master_dict['pki_audit_signing_tag'] =\
+                    "audit_signing"
+                if not len(config.pki_master_dict['pki_audit_signing_token']):
+                    config.pki_master_dict['pki_audit_signing_token'] =\
+                        "Internal Key Storage Token"
+        elif config.pki_subsystem in config.PKI_TOMCAT_SUBSYSTEMS:
+            if not config.str2bool(config.pki_master_dict['pki_clone']):
+                if not len(config.pki_master_dict\
+                           ['pki_audit_signing_nickname']):
+                    config.pki_master_dict['pki_audit_signing_nickname'] =\
+                        "auditSigningCert" + " " + "cert-" +\
+                        config.pki_master_dict['pki_instance_id']
+                if not len(config.pki_master_dict\
+                           ['pki_audit_signing_subject_dn']):
+                    if config.pki_master_dict['pki_subsystem'] == "CA":
+                        if config.str2bool(
+                               config.pki_master_dict['pki_external']):
+                            # External CA
+                            config.pki_master_dict\
+                            ['pki_audit_signing_subject_dn'] =\
+                                "cn=" + "External CA Audit Signing Certificate"\
+                                + "," + "o=" +\
+                                config.pki_master_dict\
+                                ['pki_security_domain_name']
+                        elif config.str2bool(
+                                 config.pki_master_dict['pki_subordinate']):
+                            # Subordinate CA
+                            config.pki_master_dict\
+                            ['pki_audit_signing_subject_dn'] =\
+                                "cn=" + "SubCA Audit Signing Certificate" +\
+                                "," + "o=" +\
+                                config.pki_master_dict\
+                                ['pki_security_domain_name']
+                        else:
+                            # PKI CA
+                            config.pki_master_dict\
+                            ['pki_audit_signing_subject_dn'] =\
+                                "cn=" + "CA Audit Signing Certificate" +\
+                                "," + "o=" +\
+                                config.pki_master_dict\
+                                ['pki_security_domain_name']
+                    elif config.pki_master_dict['pki_subsystem'] == "KRA":
+                        # PKI KRA
+                        config.pki_master_dict['pki_audit_signing_subject_dn']\
+                            = "cn=" + "DRM Audit Signing Certificate" +\
+                              "," + "o=" +\
+                              config.pki_master_dict['pki_security_domain_name']
+                    elif config.pki_master_dict['pki_subsystem'] == "OCSP":
+                        # PKI OCSP
+                        config.pki_master_dict['pki_audit_signing_subject_dn']\
+                            = "cn=" + "OCSP Audit Signing Certificate" +\
+                              "," + "o=" +\
+                              config.pki_master_dict['pki_security_domain_name']
+                    elif config.pki_master_dict['pki_subsystem'] == "TKS":
+                        # PKI TKS
+                        config.pki_master_dict['pki_audit_signing_subject_dn']\
+                            = "cn=" + "TKS Audit Signing Certificate" +\
+                              "," + "o=" +\
+                              config.pki_master_dict['pki_security_domain_name']
+                config.pki_master_dict['pki_audit_signing_tag'] =\
+                    "audit_signing"
+                if not len(config.pki_master_dict['pki_audit_signing_token']):
+                    config.pki_master_dict['pki_audit_signing_token'] =\
+                        "Internal Key Storage Token"
+        # Jython scriptlet
+        # 'DRM Transport Certificate' Configuration name/value pairs
+        #
+        #     Tomcat - [KRA]
+        #
+        #     The following variables are defined below:
+        #
+        #         config.pki_master_dict['pki_transport_tag']
+        #
+        #     The following variables are established via the specified PKI
+        #     deployment configuration file and are NOT redefined below:
+        #
+        #         config.pki_master_dict['pki_transport_key_algorithm']
+        #         config.pki_master_dict['pki_transport_key_size']
+        #         config.pki_master_dict['pki_transport_key_type']
+        #         config.pki_master_dict['pki_transport_signing_algorithm']
+        #
+        #     The following variables are established via the specified PKI
+        #     deployment configuration file and potentially overridden below:
+        #
+        #         config.pki_master_dict['pki_transport_nickname']
+        #         config.pki_master_dict['pki_transport_subject_dn']
+        #         config.pki_master_dict['pki_transport_token']
+        #
+        if config.pki_subsystem in config.PKI_TOMCAT_SUBSYSTEMS:
+            if not config.str2bool(config.pki_master_dict['pki_clone']):
+                if config.pki_master_dict['pki_subsystem'] == "KRA":
+                    # PKI KRA
+                    if not len(config.pki_master_dict\
+                               ['pki_transport_nickname']):
+                        config.pki_master_dict['pki_transport_nickname'] =\
+                            "transportCert" + " " + "cert-" +\
+                            config.pki_master_dict['pki_instance_id']
+                    if not len(config.pki_master_dict\
+                               ['pki_transport_subject_dn']):
+                        config.pki_master_dict['pki_transport_subject_dn']\
+                            = "cn=" + "DRM Transport Certificate" +\
+                              "," + "o=" +\
+                              config.pki_master_dict['pki_security_domain_name']
+                    config.pki_master_dict['pki_transport_tag'] =\
+                        "transport"
+                    if not len(config.pki_master_dict['pki_transport_token']):
+                        config.pki_master_dict['pki_transport_token'] =\
+                            "Internal Key Storage Token"
+        # Jython scriptlet
+        # 'DRM Storage Certificate' Configuration name/value pairs
+        #
+        #     Tomcat - [KRA]
+        #
+        #     The following variables are defined below:
+        #
+        #         config.pki_master_dict['pki_storage_tag']
+        #
+        #     The following variables are established via the specified PKI
+        #     deployment configuration file and are NOT redefined below:
+        #
+        #         config.pki_master_dict['pki_storage_key_algorithm']
+        #         config.pki_master_dict['pki_storage_key_size']
+        #         config.pki_master_dict['pki_storage_key_type']
+        #         config.pki_master_dict['pki_storage_signing_algorithm']
+        #
+        #     The following variables are established via the specified PKI
+        #     deployment configuration file and potentially overridden below:
+        #
+        #         config.pki_master_dict['pki_storage_nickname']
+        #         config.pki_master_dict['pki_storage_subject_dn']
+        #         config.pki_master_dict['pki_storage_token']
+        #
+        if config.pki_subsystem in config.PKI_TOMCAT_SUBSYSTEMS:
+            if not config.str2bool(config.pki_master_dict['pki_clone']):
+                if config.pki_master_dict['pki_subsystem'] == "KRA":
+                    # PKI KRA
+                    if not len(config.pki_master_dict['pki_storage_nickname']):
+                        config.pki_master_dict['pki_storage_nickname'] =\
+                            "storageCert" + " " + "cert-" +\
+                            config.pki_master_dict['pki_instance_id']
+                    if not len(config.pki_master_dict\
+                               ['pki_storage_subject_dn']):
+                        config.pki_master_dict['pki_storage_subject_dn']\
+                            = "cn=" + "DRM Storage Certificate" +\
+                              "," + "o=" +\
+                              config.pki_master_dict['pki_security_domain_name']
+                    config.pki_master_dict['pki_storage_tag'] =\
+                        "storage"
+                    if not len(config.pki_master_dict['pki_storage_token']):
+                        config.pki_master_dict['pki_storage_token'] =\
+                            "Internal Key Storage Token"
     except OSError as exc:
         config.pki_log.error(log.PKI_OSERROR_1, exc,
                              extra=config.PKI_INDENTATION_LEVEL_2)
         sys.exit(1)
+    except KeyError as err:
+        config.pki_log.error(log.PKIHELPER_DICTIONARY_MASTER_MISSING_KEY_1,
+                             err, extra=config.PKI_INDENTATION_LEVEL_2)
+        sys.exit(1)
     return
 
 
